<?php
/**
 * @package   DPBexio
 * @copyright Copyright (C) 2022 Digital Peak GmbH. <https://www.digital-peak.com>
 * @license   https://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 */

defined('_JEXEC') or die;

use DigitalPeak\Library\DPBexio\Bexio\APIInterface;
use DigitalPeak\Library\DPBexio\Service\APIProvider;
use DigitalPeak\Plugin\User\DPBexio\Extension\DPBexio;
use Joomla\CMS\Extension\PluginInterface;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\DI\Container;
use Joomla\DI\ServiceProviderInterface;
use Joomla\Event\DispatcherInterface;

return new class () implements ServiceProviderInterface {
	public function register(Container $container)
	{
		$container->registerServiceProvider(new APIProvider());

		$container->set(
			PluginInterface::class,
			function (Container $container) {
				return new DPBexio(
					$container->get(APIInterface::class),
					$container->get(DispatcherInterface::class),
					(array) PluginHelper::getPlugin('user', 'dpbexio')
				);
			}
		);
	}
};
