<?php
/**
 * @package   DPBexio
 * @copyright Copyright (C) 2022 Digital Peak GmbH. <https://www.digital-peak.com>
 * @license   https://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 */

namespace DigitalPeak\Library\DPBexio\Field;

use Joomla\CMS\Form\Field\ListField;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\Component\Fields\Administrator\Helper\FieldsHelper;

class CustomFieldsField extends ListField
{
	protected $type = 'CustomFieldsField';

	private $fieldAttribute;

	public function setup(\SimpleXMLElement $element, $value, $group = null)
	{
		$result = parent::setup($element, $value, $group);

		$this->fieldAttribute = $this->element['field_attribute'] ? (string) $this->element['field_attribute'] : 'id';

		return $result;
	}

	protected function getOptions()
	{
		$options = parent::getOptions();

		foreach (FieldsHelper::getFields('com_users.user') as $field) {
			$options[] = HTMLHelper::_('select.option', $field->{$this->fieldAttribute}, $field->title . ' [' . $field->name . ']');
		}

		return $options;
	}
}
