<?php
/**
 * @package   DPBexio
 * @copyright Copyright (C) 2022 Digital Peak GmbH. <https://www.digital-peak.com>
 * @license   https://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 */

namespace DigitalPeak\Library\DPBexio\Service;

use DigitalPeak\Library\DPBexio\Bexio\API;
use DigitalPeak\Library\DPBexio\Bexio\APIInterface;
use DigitalPeak\ThinHTTP;
use DigitalPeak\ThinHTTPInterface;
use Joomla\DI\Container;
use Joomla\DI\ServiceProviderInterface;

class APIProvider implements ServiceProviderInterface
{
	public function register(Container $container)
	{
		$container->set(ThinHTTPInterface::class, function (Container $container) {
			\JLoader::import('lib_dpbexio.vendor.autoload', JPATH_LIBRARIES);
			return new ThinHTTP();
		});

		$container->set(APIInterface::class, function (Container $container) {
			return new API($container->get(ThinHTTPInterface::class));
		});
	}
}
